## Write multiple key-value pairs `client.kv.namespaces.bulkUpdate(stringnamespaceId, NamespaceBulkUpdateParamsparams, RequestOptionsoptions?): NamespaceBulkUpdateResponse | null` **put** `/accounts/{account_id}/storage/kv/namespaces/{namespace_id}/bulk` Write multiple keys and values at once. Body should be an array of up to 10,000 key-value pairs to be stored, along with optional expiration information. Existing values and expirations will be overwritten. If neither `expiration` nor `expiration_ttl` is specified, the key-value pair will never expire. If both are set, `expiration_ttl` is used and `expiration` is ignored. The entire request size must be 100 megabytes or less. ### Parameters - `namespaceId: string` Namespace identifier tag. - `params: NamespaceBulkUpdateParams` - `account_id: string` Path param: Identifier. - `body: Array` Body param - `key: string` A key's name. The name may be at most 512 bytes. All printable, non-whitespace characters are valid. - `value: string` A UTF-8 encoded string to be stored, up to 25 MiB in length. - `base64?: boolean` Indicates whether or not the server should base64 decode the value before storing it. Useful for writing values that wouldn't otherwise be valid JSON strings, such as images. - `expiration?: number` Expires the key at a certain time, measured in number of seconds since the UNIX epoch. - `expiration_ttl?: number` Expires the key after a number of seconds. Must be at least 60. - `metadata?: unknown` Arbitrary JSON that is associated with a key. ### Returns - `NamespaceBulkUpdateResponse` - `successful_key_count?: number` Number of keys successfully updated. - `unsuccessful_keys?: Array` Name of the keys that failed to be fully updated. They should be retried. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.kv.namespaces.bulkUpdate('0f2ac74b498b48028cb68387c421e279', { account_id: '023e105f4ecef8ad9ca31a8372d0c353', body: [{ key: 'My-Key', value: 'Some string' }], }); console.log(response.successful_key_count); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "successful_key_count": 100, "unsuccessful_keys": [ "string" ] } } ```